from django.shortcuts import render,redirect
from django.contrib.auth.decorators import user_passes_test
from django.utils.decorators import method_decorator
from rest_framework.response import Response
from rest_framework import status
from rest_framework.views import APIView
from django.utils import timezone

from clmainApp.utils import getClinicId
from rcpmainApp.utils import getBranchId
from brvisitApp.models import PvPayment
from brpatientApp.models import Patient,PatientInfo
from clmainApp.models import *
from brmainApp.models import *
# from clmainApp.models import Nationality,FoundWay
from clmainApp.models import FoundWay,PaymentMethod


#from entagencyApp.models import TVChannel,TVProgram
#from clauthApp.models import BranchDoctor
#from ccvisitApp.models import LeadVisit,LeadStatus
from brfinanceApp.models import *
from brvisitApp.models import PatientVisit,PatientVisitSlot
from brsessionApp.models import PatientSessionItem
from .serializers import *
from datetime import date
from brsessionApp.models import Session
from django.db.models import F
class CurrentVisitsApi(APIView):
    @method_decorator(user_passes_test(lambda u: u.has_perm('Reception.view_CurrentVisits'), login_url='/auth/login/'))
    def get(self,request):
        branchId = getBranchId(request)
        if not branchId : return redirect('clauthApp:home')
        #clinicId = getClinicId(request)
        #if not branchId or not clinicId or not clinicTypeId: return redirect('clauthApp:home')
        #todayObj = date.today()
        ## get all doctors , hrsm el doctor m3 hour slot ,, w hrsm brdo drop down el doctor mnha 
        branch_patients = Patient.objects.filter(branch_id=branchId).values('id','fullname','code','number_1','number_2','rfid')
        branch_doctors = User.objects.filter(user_category="2DR",groups__branch_id=branchId,is_active=True).values('id','name')
        all_found_ways = FoundWay.objects.all()
        all_locations = Location.objects.filter(branch_id= branchId)
        timezone_now_today = timezone.now().date()
        medical_services = MedicalService.objects.filter(branch_id=branchId,is_active=True).values('id','name','price')
        all_expense_items = ExpenseItem.objects.filter(branch_id=branchId).values('id','name','category_id')
        expense_categories = ExpenseCategory.objects.all()
        patient_visits = PatientVisit.objects.filter(visit_day__lte=timezone_now_today,visit_status__in=["1I","2W","4F"]).order_by('initial_slot__order')
        #patient_visits = PatientVisit.objects.filter(
        #Q(visit_day=timezone_now_today) | Q(visit_day=timezone_now_today - timedelta(days=1)), # get today and yesterday visits 
        #Q(visit_day=timezone_now_today) | Q(visit_day__lte=timezone_now_today), # get today and yesterday visits 
        #visit_day__lte=timezone_now_today,visit_status__in=["1I","2W","4F"],
        #).order_by('initial_slot__order')
        #patient_visits_ids = patient_visits.values_list("id",flat=True)
        patient_visits_ids_today = patient_visits.filter(visit_day=timezone_now_today).values_list("id",flat=True)
        #patient , doctor , slot_id 
        patient_visits_slots = PatientVisitSlot.objects.filter(pv_id__in =patient_visits_ids_today ).values('hour_slot_id','pv__doctor_id','pv__patient__fullname')
        all_hour_slots = HourSlot.objects.filter(is_active=True).order_by('order')
        hour_slots_reserved = {}
        for d in branch_doctors:
            doctor_slots_reserved = patient_visits_slots.filter(pv__doctor_id=d["id"]).values_list("hour_slot",flat=True)
            hour_slots_reserved.update({d["id"] : doctor_slots_reserved})
            #"patient_name":patient_visits_slots.filter(pv__doctor_id=d["id"],hour_slot_id=)})
        #session_period = request.user.groups.first().clinic.session_period
        #import pdb;pdb.set_trace()
        if not request.session['SessionPeriod'] : 
            from django.contrib import auth
            auth.logout(request)
        session_period = request.session['SessionPeriod']
        patient_visits_w_i = patient_visits.filter(visit_status__in=["1I","2W"])
        patient_visits_serializer = PatientVisitDataSerializer(patient_visits_w_i,many=True,context={"session_period":session_period})
        return render(request,"Reception/rcpvisitApp/current_visits.html",{
            "branch_patients":branch_patients,
            "doctors":branch_doctors,
            "doctors__ids":list(branch_doctors.values_list('id',flat=True)),
            "session_period":session_period,
            #"ms_types":ms_types, 
            "locations":all_locations,
            "medical_services":medical_services,
            "expense_categories":expense_categories,
            "expense_items":all_expense_items,
            "payment_methods":PaymentMethod.objects.filter(is_active=True),
            #"marital_status":MARITAL_STATUS_CHOICES,
            "found_ways":all_found_ways,
            #"nationalities":Nationality.objects.all(),
            "patient_visits":patient_visits_serializer.data,
            "today_date_value":timezone_now_today.strftime("%Y-%m-%d"),
            "hour_slots_reserved":hour_slots_reserved,
            "all_hour_slots":all_hour_slots,
            "pageTitle":f" حجوزات اليوم",
            'activePage':'PatientVisit'})

def getVisitAndDaySlots(visit_day,visit_id):
        reserved_slots = PatientVisitSlot.objects.filter(pv__visit_day=visit_day).values('hour_slot_id','pv__doctor_id')
        reserved_slots_without_visit = reserved_slots.exclude(pv_id=visit_id)
        reservered_doctors_ids = set(s['pv__doctor_id'] for s in reserved_slots_without_visit)
        reserved_slots_doctors = []
        for dr_id in reservered_doctors_ids :
            reserved_slots_dr = reserved_slots_without_visit.filter(pv__doctor_id=dr_id).values_list('hour_slot_id',flat=True)
            reserved_slots_doctors.append({"dr_id":dr_id,"slots":reserved_slots_dr})
        visit_slots_data = reserved_slots.filter(pv_id=visit_id).values('hour_slot_id','pv__doctor_id')
        if visit_slots_data:
            visit_slots = {"dr_id":visit_slots_data.first()["pv__doctor_id"],"slots":visit_slots_data.values_list('hour_slot_id',flat=True)}
        else :  visit_slots = {}
        return reserved_slots_doctors,visit_slots
class EditVisitApi(APIView):
    #@method_decorator(user_passes_test(lambda u: u.has_perm('screen.add_PatientVisit'), login_url='/main/login/'))    
    def post(self,request):
        #if not getClinicId(request) : return redirect('/main/login/')
        #import pdb
        #pdb.set_trace()
        data = request.data
        visit_id = data["visit_id"]
        pv_obj = PatientVisit.objects.filter(id=visit_id).values("visit_day","visit_status").first()
        visit_day = pv_obj["visit_day"]
        visit_status = pv_obj["visit_status"]
        reserved_slots_doctors,visit_slots = getVisitAndDaySlots(visit_day,visit_id)
        return Response({"visit_day":visit_day,"visit_status":visit_status,"reserved_slots_doctors":reserved_slots_doctors,"visit_slots":visit_slots},status=status.HTTP_200_OK)
    

class DaySlotsApi(APIView):
    #@method_decorator(user_passes_test(lambda u: u.has_perm('screen.add_PatientVisit'), login_url='/main/login/'))    
    def post(self,request):
        #if not getClinicId(request) : return redirect('/main/login/')
        data = request.data
        visit_id = data["visit_id"]
        visit_day = data["visit_day"]
        reserved_slots_doctors,visit_slots = getVisitAndDaySlots(visit_day,visit_id)
        return Response({"reserved_slots_doctors":reserved_slots_doctors,"visit_slots":visit_slots},status=status.HTTP_200_OK)

from brvisitApp.models import PvPayment
from rcpvisitApp.serializers import PvPaymentSerializer

class VisitPaymentsApi(APIView): 
    def get(self,request,pv_id):
        #if not getClinicId(request) : return redirect('/main/login/')
        visit_payments = PvPayment.objects.filter(pv_id=pv_id)
        serializer=PvPaymentCustomSerializer(visit_payments,many=True)
        return Response(serializer.data,status=status.HTTP_200_OK)

    def post(self,request,pv_id):
        #if not getClinicId(request) : return redirect('/main/login/')
        data=request.data
        data._mutable = True
        data.update({"pv":pv_id})
        data.update({"created_by":request.user.id})
        serializer= PvPaymentSerializer(data=data)
        if serializer.is_valid():
            serializer.save()
            pv = PatientVisit.objects.get(id=pv_id)
            session_period = request.session['SessionPeriod']
            visit_serializer = PatientVisitCustomSerializer(pv,many=False,context={"session_period":session_period})
            return Response({"updated_visit":visit_serializer.data},status=status.HTTP_201_CREATED)
        else : return Response(serializer.errors,status=status.HTTP_400_BAD_REQUEST)


































'''
class CurrentVisitsApi(APIView):
    @method_decorator(user_passes_test(lambda u: u.has_perm('Reception.view_CurrentVisits'), login_url='/auth/login/'))
    def get(self,request):
        branchId = getBranchId(request)
        if not branchId : return redirect('clauthApp:home')
        #clinicId = getClinicId(request)
        #if not branchId or not clinicId or not clinicTypeId: return redirect('clauthApp:home')
        #todayObj = date.today()
        branch_patients = Patient.objects.filter(branch_id=branchId).values('id','fullname','code','number_1','number_2','rfid')

        #الحجوزات المؤكده هتبقى معموله سوكت عشان ممكن يحجزوا لحد وانا فاتح الصفحه ف يظهر عندى 
        #مؤقتا هنعمل اب اى تجيب حجوزات المؤكده 
        # وممكن يعمل ريفرش يجيب الحجوزات المؤكده ويرسمها تانى من الأول 
        
        #all_patients =Patient.objects.filter(branch__clinic_id=clinicId,code__isnull=True).values('id','fullname','number_1','number_2')
        #branches=Branch.objects.filter(clinic_id=clinicId,is_active=True).values('id','name')
        #clinic_branches_ids = branches.values_list('id',flat=True)
        #clinic_branches_ids = branches.values_list('id',flat=True)
        #all_nationalities = Nationality.objects.all()
        #all_locations = Location.objects.all()
        #all_channels = TVChannel.objects.filter(is_active=True).values('id','name')
        #all_programs = TVProgram.objects.filter(is_active=True).order_by('start_at')
        branch_doctors = User.objects.filter(user_category="2DR",groups__branch_id=branchId).values('id','name')
        #reception_ms = MedicalService.objects.filter(clinic_id=clinicId,is_reception_ms=True,is_active=True).values('id','name','price')

        timezone_now_today = timezone.now().date()
        return render(request,"Reception/rcpvisitApp/current_visits.html",{
            "today_date_value":timezone_now_today.strftime("%Y-%m-%d"),
            "branch_patients":branch_patients,
            "found_ways": all_found_ways,
            "locations": all_locations,
            "branch_doctors": branch_doctors,
            "all_ms": all_ms,
            "all_expense_items":all_expense_items,
            "all_expense_categories":all_expense_categories,
            "sessions":Session.objects.all().values('id','name'),
            'activePage':'CurrentVisits'})
        
        #return render(request,"visitApp/Reception/current_visits.html",{"branch_patients":branch_patients.data,'activePage':'CurrentVisits'})

    # @method_decorator(user_passes_test(lambda u: u.has_perm('screen.add_PatientVisit'), login_url='/auth/login/'))    
    # def post(self,request):
    #     if not getClinicId(request) : return redirect('/auth/login/')
    #     serializedObj= PatientVisitSerializer(data=request.data)
    #     #list_error=""
    #     if serializedObj.is_valid():
    #         serializedObj.save()
    #         return Response(status=status.HTTP_201_CREATED)
    #     else :return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)
'''
from clvoucherApp.models import PatientVoucher,PtVoucherVisits
class ActiveVisitsApi(APIView):#Today visits  == current visits 
    def get_object(self,pk):
        try:
            return PatientVisit.objects.get(pk=pk)
        except PatientVisit.DoesNotExist:
            return None    
    #@method_decorator(user_passes_test(lambda u: u.has_perm('CallCenter.add_lead_visit'), login_url='/auth/login/'))
    def get(self,request):
        branchId = getBranchId(request)
        if not branchId: return Response(status=status.HTTP_400_BAD_REQUEST)
        todayObj = date.today()
        patient_visits =PatientVisit.objects.filter(visit_day__lte=todayObj,visit_status__in=["1I","3L","2W"],visit_branch_id=branchId).order_by("-entry_order")
        patient_visits_data = []
        visit_status_i = patient_visits.filter(visit_status="1I")
        visit_status_l = patient_visits.filter(visit_status="3L")
        visit_status_w = patient_visits.filter(visit_status = "2W")
        patient_visits_data= {
        "visit_status_i":PatientVisitCustomSerializer(visit_status_i,many=True).data,
        "visit_status_l":PatientVisitCustomSerializer(visit_status_l,many=True).data,
        "visit_status_w":PatientVisitCustomSerializer(visit_status_w,many=True).data,
        }
        data = {"patient_visits_data":patient_visits_data}
        return Response(data,status=status.HTTP_200_OK)

    def post(self,request):
        branchId = getBranchId(request)
        if not branchId : return Response(status=status.HTTP_400_BAD_REQUEST)
        data = request.data
        data._mutable = True
        today_date = timezone.now().date()
        data.update({"visit_day":today_date,"created_by":request.user.id,"visit_branch":branchId})
        visits_entry_orders = PatientVisit.objects.filter(visit_day=today_date,visit_branch=branchId).aggregate(Max('entry_order'))
        v_entry_order = (int(visits_entry_orders["entry_order__max"]))+1 if visits_entry_orders["entry_order__max"] else 1
        data.update({"entry_order":v_entry_order})
        #request.data.update({"visit_status":"2W"}) this value is set by default 
        serializer= PatientVisitCustomSerializer(data=request.data)
        if serializer.is_valid():
            serializer.save()
            pt_visit_id = serializer.data["id"]
            used_voucher_id = data.get('used_voucher_id',None)
            if used_voucher_id != "0" and used_voucher_id != None :
                PtVoucherVisits.objects.create(pt_voucher_id=used_voucher_id,pt_visit_id=pt_visit_id)
            return Response(serializer.data,status=status.HTTP_201_CREATED)
        else :return Response(serializer.errors,status=status.HTTP_400_BAD_REQUEST)

    def put(self,request):#انه يعمل دخول او يغير المبلغ المدفوع او الخدمة العلاجية أو أى حاجه 
        # زرارين ( دخول - خروج ) / تعديل الحجز 
        data = request.data
        pv=self.get_object(data["pv_id"])
        data._mutable = True
        if pv :
            if 'visit_status'in data :
                if data['visit_status']== '2W' :
                    today_date = timezone.now().date()
                    visits_entry_orders = PatientVisit.objects.filter(visit_day=today_date,visit_branch=pv.visit_branch).aggregate(Max('entry_order'))
                    v_entry_order = (int(visits_entry_orders["entry_order__max"]))+1 if visits_entry_orders["entry_order__max"] else 1
                    data.update({"entry_order":v_entry_order})
            serializer= PatientVisitCustomSerializer(pv,data=data,partial=True)
            #request.data.update({"visit_status":"2W"}) this value is set by default 
            if serializer.is_valid():
                serializer.save()
                response_data = serializer.data
                if data['visit_status']== '1I' :
                    patient_id = response_data["patient"]
                    # check if patient has sessions (end or inside)
                    PatientSessionItem_count =  PatientSessionItem.objects.filter(session__patient_id=patient_id,entry_status__in=["1I","4F"]).count()
                    if PatientSessionItem_count == 0 :
                        PatientInfo.objects.filter(patient_id=patient_id).update(marketing_code="V_NO_S",last_visit=timezone.now())
                    else :
                        PatientInfo.objects.filter(patient_id=patient_id).update(last_visit=timezone.now())

                return Response(response_data,status=status.HTTP_200_OK)
            else :return Response(serializer.errors,status=status.HTTP_400_BAD_REQUEST)
        else :return Response("PatientVisit Not Found .",status=status.HTTP_400_BAD_REQUEST)

    #@method_decorator(user_passes_test(lambda u: u.has_perm('screen.delete_patients'), login_url='/auth/login/'))
    def delete(self,request):
        data = request.data
        pv_id = data["pv_id"]
        pv=self.get_object(pv_id)
        if pv :
            try:
                PvPayment.objects.filter(pv=pv).delete()
                pv.delete()
                return Response(status=status.HTTP_204_NO_CONTENT)
            except Exception as err_msg: 
                    return Response(data ="{}".format(str(err_msg)),status=status.HTTP_405_METHOD_NOT_ALLOWED)
        else : return Response(status=status.HTTP_404_NOT_FOUND)

            # data._mutable = True
            # data.update({"visit_status":"5C","amount_required":0,"amount_paid":0,"amount_remaining":0})
            # pv_serializer= PatientVisitCustomSerializer(pv,data=data,partial=True)
            # if pv_serializer.is_valid():
            #     pv_serializer.save()
            #     #add pv cancel data
            #     data.update({"created_by":request.user.id})#cancel_notes هتيجى من فرونت مع اى دى الزيارة نفسها 
            #     pv_cancel_serializer= PvCancelSerializer(data=data)
            #     if pv_cancel_serializer.is_valid():
            #         pv_cancel_serializer.save()
                    #return Response(pv_id,status=status.HTTP_204_NO_CONTENT)
                #else :return Response(pv_cancel_serializer.errors,status=status.HTTP_400_BAD_REQUEST)
            #else :return Response(pv_serializer.errors,status=status.HTTP_400_BAD_REQUEST)
        #else :return Response("PatientVisit Not Found .",status=status.HTTP_400_BAD_REQUEST)


def patient_info(request):
    if not getBranchId(request) : return redirect('/main/login/')
    patients =Patient.objects.all().values("id","code","fullname")
    return render(request,"receptionApp/patientPages/patientData/patient_info.html",{
        "patients":patients,})

class VisitRelatedPaymentsApi(APIView): 
    def get(self,request,pv_id):
        pv_payments = PvPayment.objects.filter(pv_id=pv_id)
        serializer=PvPaymentSerializer(pv_payments,many=True)
        return Response(serializer.data,status=status.HTTP_200_OK)

    def post(self,request,pv_id):
        request.data._mutable = True
        request.data.update({"pv":pv_id})
        request.data.update({"created_by":request.user.id})
        serializer= PvPaymentSerializer(data=request.data)
        if serializer.is_valid():
            serializer.save()
            pv = PatientVisit.objects.get(id=pv_id)
            pv_serializer = PatientVisitCustomSerializer(pv,many=False)
            return Response({"updated_obj":pv_serializer.data},status=status.HTTP_201_CREATED)
        else : return Response(serializer.errors,status=status.HTTP_400_BAD_REQUEST)

class VisitExtraInfoApi(APIView): 
    def get(self,request,pv_id):
        pv_payments = PatientVisit.objects.filter(id=pv_id)
        serializer=VisitExtraInfoSerializer(pv_payments,many=True)
        return Response(serializer.data,status=status.HTTP_200_OK)


'''
#@login_required(login_url='mainApp:login')
def visits(request):
    if not getClinicId(request) : return redirect('/main/login/')
    ## get all doctors , hrsm el doctor m3 hour slot ,, w hrsm brdo drop down el doctor mnha 
    all_patients =Patient.objects.all().values('id','fullname','code','last_visit','number_1','number_2','balance','is_bannded')
    doctors =User.objects.filter(is_doctor=True,is_active=True).values("id","first_name","last_name")
    #max_code = all_patients.aggregate(Max('code'))
    #if max_code["code__max"] : new_code_value = int(max_code["code__max"])+1
    #else : new_code_value = 1
    # all_patients_serialized=PatientMiniSerializer(all_patients,many=True)
    #all_organization =Organization.objects.all()
   # all_companies =Company.objects.all()
    #all_organization_serialized=OrganizationSerializer(all_organization,many=True)
    #all_companies_serialized=CompanySerializer(all_companies,many=True)
    timezone_now_today = timezone.now().date()
    #lst_visit_status_i_l = ["1I","3L"]#3nd el doctor w t25ir 
    #lst_visit_status_w = ["2W"]
    ms_types =MsType.objects.all()
    #context.update({"ms_types":ms_types})
    #medical_services =MedicalService.objects.filter(ms_type__is_doctor_ms=False).values('id', 'name','price')
    medical_services =MedicalService.objects.filter(is_active=True).values('id', 'name','price','ms_type_id','ms_type__is_doctor_ms')
    expense_items =ExpenseItem.objects.all().values('id', 'name')
    patient_visits = PatientVisit.objects.filter(visit_day__lte=timezone_now_today,visit_status__in=["1I","2W","4F"]).annotate(invoice_amount_remaining=F('patient__PatientInvoice_patient__amount_remaining'),invoice_id=F('patient__PatientInvoice_patient__pk')).order_by('initial_slot__order')
    #patient_visits = PatientVisit.objects.filter(
    #Q(visit_day=timezone_now_today) | Q(visit_day=timezone_now_today - timedelta(days=1)), # get today and yesterday visits 
    #Q(visit_day=timezone_now_today) | Q(visit_day__lte=timezone_now_today), # get today and yesterday visits 
    #visit_day__lte=timezone_now_today,visit_status__in=["1I","2W","4F"],
    #).order_by('initial_slot__order')
    #patient_visits_ids = patient_visits.values_list("id",flat=True)
    patient_visits_ids_today = patient_visits.filter(visit_day=timezone_now_today).values_list("id",flat=True)
    #patient , doctor , slot_id 
    patient_visits_slots = PatientVisitSlot.objects.filter(pv_id__in =patient_visits_ids_today ).values('hour_slot_id','pv__doctor_id','pv__patient__fullname')
    all_hour_slots = HourSlot.objects.filter(is_active=True).order_by('order')
    hour_slots_reserved = {}
    for d in doctors:
        doctor_slots_reserved = patient_visits_slots.filter(pv__doctor_id=d["id"]).values_list("hour_slot",flat=True)
        hour_slots_reserved.update({d["id"] : doctor_slots_reserved})
        #"patient_name":patient_visits_slots.filter(pv__doctor_id=d["id"],hour_slot_id=)})
    #session_period = request.user.groups.first().clinic.session_period
    if not request.session['SessionPeriod'] : 
        from django.contrib import auth
        auth.logout(request)
    session_period = request.session['SessionPeriod']
    patient_visits_w_i = patient_visits.filter(visit_status__in=["1I","2W"])
    patient_visits_serializer = PatientVisitCustomSerializer(patient_visits_w_i,many=True,context={"session_period":session_period})
    return render(request,"Reception/rcpvisitApp/visits.html",{
        "all_patients":all_patients,
        "doctors":doctors,
        "doctors__ids":list(doctors.values_list('id',flat=True)),
        "session_period":session_period,
        "ms_types":ms_types, 
        "medical_services":medical_services,
        "expense_items":expense_items,
        "payment_methods":PaymentMethod.objects.filter(is_active=True),
        #"marital_status":MARITAL_STATUS_CHOICES,
        "found_ways":FoundWay.objects.all(),
        #"nationalities":Nationality.objects.all(),
        "patient_visits":patient_visits_serializer.data,
        "today_date_value":timezone_now_today.strftime("%Y-%m-%d"),
        "hour_slots_reserved":hour_slots_reserved,
        "all_hour_slots":all_hour_slots,
        "pageTitle":f" حجوزات اليوم",
        'activePage':'PatientVisit'})
'''
class PatientVisitsApi(APIView):
    # @method_decorator(user_passes_test(lambda u: u.has_perm('screen.view_patients'), login_url='/main/login/'))
    # def get(self,request):
    #     if not getClinicId(request) : return redirect('/main/login/')
    #     all_patients =Patient.objects.all()
    #     all_patients_serialized=PatientSerializer(all_patients,many=True)
    #     return render(request,"mainApp/patients.html",{"all_patients":all_patients_serialized.data,'activePage':'Patients'})

    # @method_decorator(user_passes_test(lambda u: u.has_perm('screen.add_patients'), login_url='/main/login/'))    
    def post(self,request):
        #if not getClinicId(request) : return redirect('/main/login/')
        #context = {"amount_required": request.data.get("amount_required")}
        branchId = getBranchId(request)
        if not branchId : return Response(status=status.HTTP_400_BAD_REQUEST)
        data = request.data
        data._mutable = True
        #data.update({"visit_day":timezone.now().date(),"created_by":request.user.id})
        if "visit_day" not in data :
            today_date = timezone.now().date()
            data.update({"visit_day":today_date})
        data.update({"created_by":request.user.id,"visit_branch":branchId})
        selected_slots_ids = data.getlist("hour_slots[]")
        #first_slot_id = min(selected_slots_ids)
        first_slot_id = min(map(int, selected_slots_ids)) 
        data.update({"slots_count":len(selected_slots_ids),"initial_slot":first_slot_id})
        #session_period = request.user.groups.first().clinic.session_period
        session_period = request.session['SessionPeriod']
        is_confirmed = data["is_confirmed"]
        if is_confirmed : data.update({"confirmed_by":request.user.id})
        pv_serilaizer= PatientVisitDataSerializer(data=data,context={"session_period":session_period})
        if pv_serilaizer.is_valid():
            pv_serilaizer.save()
            pv_serilaizer_data = pv_serilaizer.data
            pv_id = pv_serilaizer.data["id"]
            pv_slots = []
            selected_slots_ids = [int(s_id) for s_id in selected_slots_ids]
            for s_id in selected_slots_ids: pv_slots.append({"pv":pv_id,"hour_slot":s_id}) 
            pv_slots_serializer= PatientVisitSlotSerializer(data=pv_slots,many=True)
            if pv_slots_serializer.is_valid():
                pv_slots_serializer.save()
                hour_slot = HourSlot.objects.filter(id=first_slot_id).values('id','name','order').first()
                # get user invoice data 
                return Response({"pv":pv_serilaizer_data,"hs":hour_slot},status=status.HTTP_201_CREATED)
        else :return Response(pv_serilaizer.errors,status=status.HTTP_400_BAD_REQUEST)


class PatientVisitApi(APIView):
    def get_object(self,pk):
        try:
            return PatientVisit.objects.get(pk=pk)
        except PatientVisit.DoesNotExist:
            return None    
    
    # @method_decorator(user_passes_test(lambda u: u.has_perm('screen.view_medicalService'), login_url='/main/login/'))        
    # def get(self,request,pk): 
    #     medical_serviceObj=self.get_object(pk)
    #     if medical_serviceObj :
    #         #return render(request,"mainApp/medical_service.html",{"medical_service":medical_serviceObj,'activePage':'MedicalServices'})
    #         serializeobj= MedicalServiceSerializer(medical_serviceObj)
    #         return Response(serializeobj.data,status=status.HTTP_200_OK)
    #     else : return Response(status=status.HTTP_404_NOT_FOUND)
    
    # @method_decorator(user_passes_test(lambda u: u.has_perm('screen.edit_medicalService'), login_url='/main/login/'))
    def put(self,request,pk):
        obj=self.get_object(pk)
        request.data._mutable = True
        data = request.data
        #session_period = request.user.groups.first().clinic.session_period
        session_period = request.session['SessionPeriod']
        if "is_confirmed" in data :
            is_confirmed = data["is_confirmed"]
            if is_confirmed : data.update({"confirmed_by":request.user.id})
        if "visit_status" in data :
            pv_serilaizer= PatientVisitCustomSerializer(obj,data=request.data,partial=True,context={"session_period":session_period})
            if pv_serilaizer.is_valid():
                pv_serilaizer.save()
                if data["visit_status"] == "5C" :
                    slots_doctor_id =obj.doctor_id
                    PatientVisitSlot.objects.filter(pv=obj).delete()
                    #PvPayment.objects.filter(pv=obj).delete()
                    #obj.delete()
                    if "today_date" in request.data :
                        today_date = data["today_date"]
                        today_hour_slots = PatientVisitSlot.objects.filter(pv__visit_day=today_date,pv__doctor_id=slots_doctor_id).values_list('hour_slot_id',flat=True)
                        data.update({"today_hour_slots":today_hour_slots,"slots_doctor_id":slots_doctor_id})
                return Response(data,status=status.HTTP_200_OK)
            else :return Response(pv_serilaizer.errors,status=status.HTTP_400_BAD_REQUEST)
        if "visit_day" in data :
            selected_slots_ids = data.getlist("hour_slots[]")
            #first_slot_id = min(selected_slots_ids)
            first_slot_id = min(map(int, selected_slots_ids)) 
            data.update({"slots_count":len(selected_slots_ids),"initial_slot":first_slot_id})
            today_date = data["today_date"]
            visit_day = data["visit_day"]
            #pv_serilaizer= PatientVisitCustomSerializer(data=data,context={"session_period":session_period})
            pv_serilaizer= PatientVisitCustomSerializer(obj,data=request.data,partial=True,context={"session_period":session_period})
            if pv_serilaizer.is_valid():
                pv_serilaizer.save()
                pv_id = pv_serilaizer.data["id"]
                pv_slots = []
                selected_slots_ids = [int(s_id) for s_id in selected_slots_ids]
                for s_id in selected_slots_ids: pv_slots.append({"pv":pv_id,"hour_slot":s_id}) 
                pv_slots_serializer= PatientVisitSlotSerializer(data=pv_slots,many=True)
                PatientVisitSlot.objects.filter(pv_id=pv_id).delete()
                if pv_slots_serializer.is_valid():
                    pv_slots_serializer.save()
                    if "today_date" not in data : today_date = timezone.now().date()
                    today_hour_slots = PatientVisitSlot.objects.filter(pv__visit_day=today_date).values_list('hour_slot_id',flat=True)
                    data = {"today_hour_slots":today_hour_slots}
                    if (visit_day == today_date) : data.update({"pv":pv_serilaizer.data})
                    return Response(data,status=status.HTTP_200_OK)
                else :return Response(pv_slots_serializer.errors,status=status.HTTP_400_BAD_REQUEST)
            else :return Response(pv_serilaizer.errors,status=status.HTTP_400_BAD_REQUEST)
        pv_serilaizer= PatientVisitCustomSerializer(obj,data=request.data,partial=True,context={"session_period":session_period})
        if pv_serilaizer.is_valid():
            pv_serilaizer.save()
            return Response(data,status=status.HTTP_200_OK)
        else :return Response(pv_slots_serializer.errors,status=status.HTTP_400_BAD_REQUEST)

    # @method_decorator(user_passes_test(lambda u: u.has_perm('screen.delete_medicalService'), login_url='/main/login/'))
    def delete(self,request,pk):
        obj=self.get_object(pk)
        if obj :
            try:
                slots_doctor_id =obj.doctor_id
                PatientVisitSlot.objects.filter(pv=obj).delete()
                PvPayment.objects.filter(pv=obj).delete()
                obj.delete()
                if "today_date" in request.data :
                    today_date = request.data["today_date"]
                    today_hour_slots = PatientVisitSlot.objects.filter(pv__visit_day=today_date,pv__doctor_id=slots_doctor_id).values_list('hour_slot_id',flat=True)
                    data = {"today_hour_slots":today_hour_slots,"slots_doctor_id":slots_doctor_id}
                    return Response(data , status=status.HTTP_200_OK)
                return Response(status=status.HTTP_204_NO_CONTENT)
            except Exception as err_msg: 
                    return Response(data ="{}".format(str(err_msg)),status=status.HTTP_405_METHOD_NOT_ALLOWED)
        else : return Response(status=status.HTTP_404_NOT_FOUND)



class InsideVisitsApi(APIView):
    def get(self,request):
        if not getClinicId(request) : return redirect('/main/login/')
        inside_visits =PatientVisit.objects.filter(visit_status="1I").order_by("id")
        inside_visits_srl=PatientVisitSerializer(inside_visits,many=True)
        return Response(inside_visits_srl.data,status=status.HTTP_200_OK)